// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ml_classifiers:msg/ClassDataPoint.idl
// generated code does not contain a copyright notice

#ifndef ML_CLASSIFIERS__MSG__CLASS_DATA_POINT__FUNCTIONS_H_
#define ML_CLASSIFIERS__MSG__CLASS_DATA_POINT__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "ml_classifiers/msg/rosidl_generator_c__visibility_control.h"

#include "ml_classifiers/msg/class_data_point__struct.h"

/// Initialize msg/ClassDataPoint message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * ml_classifiers__msg__ClassDataPoint
 * )) before or use
 * ml_classifiers__msg__ClassDataPoint__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
bool
ml_classifiers__msg__ClassDataPoint__init(ml_classifiers__msg__ClassDataPoint * msg);

/// Finalize msg/ClassDataPoint message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
void
ml_classifiers__msg__ClassDataPoint__fini(ml_classifiers__msg__ClassDataPoint * msg);

/// Create msg/ClassDataPoint message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * ml_classifiers__msg__ClassDataPoint__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
ml_classifiers__msg__ClassDataPoint *
ml_classifiers__msg__ClassDataPoint__create();

/// Destroy msg/ClassDataPoint message.
/**
 * It calls
 * ml_classifiers__msg__ClassDataPoint__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
void
ml_classifiers__msg__ClassDataPoint__destroy(ml_classifiers__msg__ClassDataPoint * msg);


/// Initialize array of msg/ClassDataPoint messages.
/**
 * It allocates the memory for the number of elements and calls
 * ml_classifiers__msg__ClassDataPoint__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
bool
ml_classifiers__msg__ClassDataPoint__Sequence__init(ml_classifiers__msg__ClassDataPoint__Sequence * array, size_t size);

/// Finalize array of msg/ClassDataPoint messages.
/**
 * It calls
 * ml_classifiers__msg__ClassDataPoint__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
void
ml_classifiers__msg__ClassDataPoint__Sequence__fini(ml_classifiers__msg__ClassDataPoint__Sequence * array);

/// Create array of msg/ClassDataPoint messages.
/**
 * It allocates the memory for the array and calls
 * ml_classifiers__msg__ClassDataPoint__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
ml_classifiers__msg__ClassDataPoint__Sequence *
ml_classifiers__msg__ClassDataPoint__Sequence__create(size_t size);

/// Destroy array of msg/ClassDataPoint messages.
/**
 * It calls
 * ml_classifiers__msg__ClassDataPoint__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
void
ml_classifiers__msg__ClassDataPoint__Sequence__destroy(ml_classifiers__msg__ClassDataPoint__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // ML_CLASSIFIERS__MSG__CLASS_DATA_POINT__FUNCTIONS_H_
