// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ml_classifiers:srv/CreateClassifier.idl
// generated code does not contain a copyright notice
#include "ml_classifiers/srv/create_classifier__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `identifier`
// Member `class_type`
#include "rosidl_generator_c/string_functions.h"

bool
ml_classifiers__srv__CreateClassifier_Request__init(ml_classifiers__srv__CreateClassifier_Request * msg)
{
  if (!msg) {
    return false;
  }
  // identifier
  if (!rosidl_generator_c__String__init(&msg->identifier)) {
    ml_classifiers__srv__CreateClassifier_Request__destroy(msg);
    return false;
  }
  // class_type
  if (!rosidl_generator_c__String__init(&msg->class_type)) {
    ml_classifiers__srv__CreateClassifier_Request__destroy(msg);
    return false;
  }
  return true;
}

void
ml_classifiers__srv__CreateClassifier_Request__fini(ml_classifiers__srv__CreateClassifier_Request * msg)
{
  if (!msg) {
    return;
  }
  // identifier
  rosidl_generator_c__String__fini(&msg->identifier);
  // class_type
  rosidl_generator_c__String__fini(&msg->class_type);
}

ml_classifiers__srv__CreateClassifier_Request *
ml_classifiers__srv__CreateClassifier_Request__create()
{
  ml_classifiers__srv__CreateClassifier_Request * msg = (ml_classifiers__srv__CreateClassifier_Request *)malloc(sizeof(ml_classifiers__srv__CreateClassifier_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ml_classifiers__srv__CreateClassifier_Request));
  bool success = ml_classifiers__srv__CreateClassifier_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ml_classifiers__srv__CreateClassifier_Request__destroy(ml_classifiers__srv__CreateClassifier_Request * msg)
{
  if (msg) {
    ml_classifiers__srv__CreateClassifier_Request__fini(msg);
  }
  free(msg);
}


bool
ml_classifiers__srv__CreateClassifier_Request__Sequence__init(ml_classifiers__srv__CreateClassifier_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ml_classifiers__srv__CreateClassifier_Request * data = NULL;
  if (size) {
    data = (ml_classifiers__srv__CreateClassifier_Request *)calloc(size, sizeof(ml_classifiers__srv__CreateClassifier_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ml_classifiers__srv__CreateClassifier_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ml_classifiers__srv__CreateClassifier_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ml_classifiers__srv__CreateClassifier_Request__Sequence__fini(ml_classifiers__srv__CreateClassifier_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ml_classifiers__srv__CreateClassifier_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ml_classifiers__srv__CreateClassifier_Request__Sequence *
ml_classifiers__srv__CreateClassifier_Request__Sequence__create(size_t size)
{
  ml_classifiers__srv__CreateClassifier_Request__Sequence * array = (ml_classifiers__srv__CreateClassifier_Request__Sequence *)malloc(sizeof(ml_classifiers__srv__CreateClassifier_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ml_classifiers__srv__CreateClassifier_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ml_classifiers__srv__CreateClassifier_Request__Sequence__destroy(ml_classifiers__srv__CreateClassifier_Request__Sequence * array)
{
  if (array) {
    ml_classifiers__srv__CreateClassifier_Request__Sequence__fini(array);
  }
  free(array);
}


bool
ml_classifiers__srv__CreateClassifier_Response__init(ml_classifiers__srv__CreateClassifier_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  return true;
}

void
ml_classifiers__srv__CreateClassifier_Response__fini(ml_classifiers__srv__CreateClassifier_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
}

ml_classifiers__srv__CreateClassifier_Response *
ml_classifiers__srv__CreateClassifier_Response__create()
{
  ml_classifiers__srv__CreateClassifier_Response * msg = (ml_classifiers__srv__CreateClassifier_Response *)malloc(sizeof(ml_classifiers__srv__CreateClassifier_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ml_classifiers__srv__CreateClassifier_Response));
  bool success = ml_classifiers__srv__CreateClassifier_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ml_classifiers__srv__CreateClassifier_Response__destroy(ml_classifiers__srv__CreateClassifier_Response * msg)
{
  if (msg) {
    ml_classifiers__srv__CreateClassifier_Response__fini(msg);
  }
  free(msg);
}


bool
ml_classifiers__srv__CreateClassifier_Response__Sequence__init(ml_classifiers__srv__CreateClassifier_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ml_classifiers__srv__CreateClassifier_Response * data = NULL;
  if (size) {
    data = (ml_classifiers__srv__CreateClassifier_Response *)calloc(size, sizeof(ml_classifiers__srv__CreateClassifier_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ml_classifiers__srv__CreateClassifier_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ml_classifiers__srv__CreateClassifier_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ml_classifiers__srv__CreateClassifier_Response__Sequence__fini(ml_classifiers__srv__CreateClassifier_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ml_classifiers__srv__CreateClassifier_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ml_classifiers__srv__CreateClassifier_Response__Sequence *
ml_classifiers__srv__CreateClassifier_Response__Sequence__create(size_t size)
{
  ml_classifiers__srv__CreateClassifier_Response__Sequence * array = (ml_classifiers__srv__CreateClassifier_Response__Sequence *)malloc(sizeof(ml_classifiers__srv__CreateClassifier_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ml_classifiers__srv__CreateClassifier_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ml_classifiers__srv__CreateClassifier_Response__Sequence__destroy(ml_classifiers__srv__CreateClassifier_Response__Sequence * array)
{
  if (array) {
    ml_classifiers__srv__CreateClassifier_Response__Sequence__fini(array);
  }
  free(array);
}
