#ifndef _H_BD9CCB79B075A52C7FCF34441E93CF35_ClearClassifier__H_
#define _H_BD9CCB79B075A52C7FCF34441E93CF35_ClearClassifier__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            struct  ClearClassifier_Request_
            {
                ::DDS::String_mgr identifier_;
            };

            typedef DDS_DCPSStruct_var<ClearClassifier_Request_> ClearClassifier_Request__var;
            typedef DDS_DCPSStruct_out < ClearClassifier_Request_> ClearClassifier_Request__out;

            struct  ClearClassifier_Response_
            {
                ::DDS::Boolean success_;
            };

            typedef DDS_DCPSStruct_var<ClearClassifier_Response_> ClearClassifier_Response__var;
            typedef ClearClassifier_Response_& ClearClassifier_Response__out;

            struct  Sample_ClearClassifier_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::ClearClassifier_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ClearClassifier_Request_> Sample_ClearClassifier_Request__var;
            typedef DDS_DCPSStruct_out < Sample_ClearClassifier_Request_> Sample_ClearClassifier_Request__out;

            struct  Sample_ClearClassifier_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::ClearClassifier_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ClearClassifier_Response_> Sample_ClearClassifier_Response__var;
            typedef Sample_ClearClassifier_Response_& Sample_ClearClassifier_Response__out;

        }

    }

}

#endif /* _H_BD9CCB79B075A52C7FCF34441E93CF35_ClearClassifier__H_ */
