#ifndef _H_BF4532218B6742C47E8A1256E2352C44_LoadClassifier__H_
#define _H_BF4532218B6742C47E8A1256E2352C44_LoadClassifier__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            struct  LoadClassifier_Request_
            {
                ::DDS::String_mgr identifier_;
                ::DDS::String_mgr class_type_;
                ::DDS::String_mgr filename_;
            };

            typedef DDS_DCPSStruct_var<LoadClassifier_Request_> LoadClassifier_Request__var;
            typedef DDS_DCPSStruct_out < LoadClassifier_Request_> LoadClassifier_Request__out;

            struct  LoadClassifier_Response_
            {
                ::DDS::Boolean success_;
            };

            typedef DDS_DCPSStruct_var<LoadClassifier_Response_> LoadClassifier_Response__var;
            typedef LoadClassifier_Response_& LoadClassifier_Response__out;

            struct  Sample_LoadClassifier_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::LoadClassifier_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_LoadClassifier_Request_> Sample_LoadClassifier_Request__var;
            typedef DDS_DCPSStruct_out < Sample_LoadClassifier_Request_> Sample_LoadClassifier_Request__out;

            struct  Sample_LoadClassifier_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::LoadClassifier_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_LoadClassifier_Response_> Sample_LoadClassifier_Response__var;
            typedef Sample_LoadClassifier_Response_& Sample_LoadClassifier_Response__out;

        }

    }

}

#endif /* _H_BF4532218B6742C47E8A1256E2352C44_LoadClassifier__H_ */
