#ifndef _H_10FAE4357F80CB7FD9A6F58E1F5EA017_ClassifyData_DCPS_H_
#define _H_10FAE4357F80CB7FD9A6F58E1F5EA017_ClassifyData_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ClassifyData_.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            class ClassifyData_Request_TypeSupportInterface;

            typedef ClassifyData_Request_TypeSupportInterface * ClassifyData_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ClassifyData_Request_TypeSupportInterface> ClassifyData_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ClassifyData_Request_TypeSupportInterface> ClassifyData_Request_TypeSupportInterface_out;


            class ClassifyData_Request_DataWriter;

            typedef ClassifyData_Request_DataWriter * ClassifyData_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ClassifyData_Request_DataWriter> ClassifyData_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ClassifyData_Request_DataWriter> ClassifyData_Request_DataWriter_out;


            class ClassifyData_Request_DataReader;

            typedef ClassifyData_Request_DataReader * ClassifyData_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ClassifyData_Request_DataReader> ClassifyData_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ClassifyData_Request_DataReader> ClassifyData_Request_DataReader_out;


            class ClassifyData_Request_DataReaderView;

            typedef ClassifyData_Request_DataReaderView * ClassifyData_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ClassifyData_Request_DataReaderView> ClassifyData_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ClassifyData_Request_DataReaderView> ClassifyData_Request_DataReaderView_out;

            struct ClassifyData_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ClassifyData_Request_, struct ClassifyData_Request_Seq_uniq_> ClassifyData_Request_Seq;
            typedef DDS_DCPSSequence_var < ClassifyData_Request_Seq> ClassifyData_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ClassifyData_Request_Seq> ClassifyData_Request_Seq_out;

            class  ClassifyData_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ClassifyData_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ClassifyData_Request_TypeSupportInterface_var _var_type;

                static ClassifyData_Request_TypeSupportInterface_ptr _duplicate (ClassifyData_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClassifyData_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ClassifyData_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClassifyData_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ClassifyData_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ClassifyData_Request_TypeSupportInterface () {};
                ~ClassifyData_Request_TypeSupportInterface () {};
            private:
                ClassifyData_Request_TypeSupportInterface (const ClassifyData_Request_TypeSupportInterface &);
                ClassifyData_Request_TypeSupportInterface & operator = (const ClassifyData_Request_TypeSupportInterface &);
            };

            class  ClassifyData_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ClassifyData_Request_DataWriter_ptr _ptr_type;
                typedef ClassifyData_Request_DataWriter_var _var_type;

                static ClassifyData_Request_DataWriter_ptr _duplicate (ClassifyData_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClassifyData_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ClassifyData_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClassifyData_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ClassifyData_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ClassifyData_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ClassifyData_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ClassifyData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ClassifyData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ClassifyData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ClassifyData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ClassifyData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ClassifyData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ClassifyData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ClassifyData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ClassifyData_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClassifyData_Request_& instance_data) = 0;

            protected:
                ClassifyData_Request_DataWriter () {};
                ~ClassifyData_Request_DataWriter () {};
            private:
                ClassifyData_Request_DataWriter (const ClassifyData_Request_DataWriter &);
                ClassifyData_Request_DataWriter & operator = (const ClassifyData_Request_DataWriter &);
            };

            class  ClassifyData_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ClassifyData_Request_DataReader_ptr _ptr_type;
                typedef ClassifyData_Request_DataReader_var _var_type;

                static ClassifyData_Request_DataReader_ptr _duplicate (ClassifyData_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClassifyData_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ClassifyData_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClassifyData_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ClassifyData_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClassifyData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClassifyData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClassifyData_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClassifyData_Request_& instance) = 0;

            protected:
                ClassifyData_Request_DataReader () {};
                ~ClassifyData_Request_DataReader () {};
            private:
                ClassifyData_Request_DataReader (const ClassifyData_Request_DataReader &);
                ClassifyData_Request_DataReader & operator = (const ClassifyData_Request_DataReader &);
            };

            class  ClassifyData_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ClassifyData_Request_DataReaderView_ptr _ptr_type;
                typedef ClassifyData_Request_DataReaderView_var _var_type;

                static ClassifyData_Request_DataReaderView_ptr _duplicate (ClassifyData_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClassifyData_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ClassifyData_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClassifyData_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ClassifyData_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClassifyData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClassifyData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClassifyData_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClassifyData_Request_& instance) = 0;

            protected:
                ClassifyData_Request_DataReaderView () {};
                ~ClassifyData_Request_DataReaderView () {};
            private:
                ClassifyData_Request_DataReaderView (const ClassifyData_Request_DataReaderView &);
                ClassifyData_Request_DataReaderView & operator = (const ClassifyData_Request_DataReaderView &);
            };
            class ClassifyData_Response_TypeSupportInterface;

            typedef ClassifyData_Response_TypeSupportInterface * ClassifyData_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ClassifyData_Response_TypeSupportInterface> ClassifyData_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ClassifyData_Response_TypeSupportInterface> ClassifyData_Response_TypeSupportInterface_out;


            class ClassifyData_Response_DataWriter;

            typedef ClassifyData_Response_DataWriter * ClassifyData_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ClassifyData_Response_DataWriter> ClassifyData_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ClassifyData_Response_DataWriter> ClassifyData_Response_DataWriter_out;


            class ClassifyData_Response_DataReader;

            typedef ClassifyData_Response_DataReader * ClassifyData_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ClassifyData_Response_DataReader> ClassifyData_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ClassifyData_Response_DataReader> ClassifyData_Response_DataReader_out;


            class ClassifyData_Response_DataReaderView;

            typedef ClassifyData_Response_DataReaderView * ClassifyData_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ClassifyData_Response_DataReaderView> ClassifyData_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ClassifyData_Response_DataReaderView> ClassifyData_Response_DataReaderView_out;

            struct ClassifyData_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ClassifyData_Response_, struct ClassifyData_Response_Seq_uniq_> ClassifyData_Response_Seq;
            typedef DDS_DCPSSequence_var < ClassifyData_Response_Seq> ClassifyData_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ClassifyData_Response_Seq> ClassifyData_Response_Seq_out;

            class  ClassifyData_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ClassifyData_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ClassifyData_Response_TypeSupportInterface_var _var_type;

                static ClassifyData_Response_TypeSupportInterface_ptr _duplicate (ClassifyData_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClassifyData_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ClassifyData_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClassifyData_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ClassifyData_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ClassifyData_Response_TypeSupportInterface () {};
                ~ClassifyData_Response_TypeSupportInterface () {};
            private:
                ClassifyData_Response_TypeSupportInterface (const ClassifyData_Response_TypeSupportInterface &);
                ClassifyData_Response_TypeSupportInterface & operator = (const ClassifyData_Response_TypeSupportInterface &);
            };

            class  ClassifyData_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ClassifyData_Response_DataWriter_ptr _ptr_type;
                typedef ClassifyData_Response_DataWriter_var _var_type;

                static ClassifyData_Response_DataWriter_ptr _duplicate (ClassifyData_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClassifyData_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ClassifyData_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClassifyData_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ClassifyData_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ClassifyData_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ClassifyData_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ClassifyData_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ClassifyData_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ClassifyData_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ClassifyData_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ClassifyData_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ClassifyData_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ClassifyData_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ClassifyData_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ClassifyData_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClassifyData_Response_& instance_data) = 0;

            protected:
                ClassifyData_Response_DataWriter () {};
                ~ClassifyData_Response_DataWriter () {};
            private:
                ClassifyData_Response_DataWriter (const ClassifyData_Response_DataWriter &);
                ClassifyData_Response_DataWriter & operator = (const ClassifyData_Response_DataWriter &);
            };

            class  ClassifyData_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ClassifyData_Response_DataReader_ptr _ptr_type;
                typedef ClassifyData_Response_DataReader_var _var_type;

                static ClassifyData_Response_DataReader_ptr _duplicate (ClassifyData_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClassifyData_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ClassifyData_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClassifyData_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ClassifyData_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClassifyData_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClassifyData_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClassifyData_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClassifyData_Response_& instance) = 0;

            protected:
                ClassifyData_Response_DataReader () {};
                ~ClassifyData_Response_DataReader () {};
            private:
                ClassifyData_Response_DataReader (const ClassifyData_Response_DataReader &);
                ClassifyData_Response_DataReader & operator = (const ClassifyData_Response_DataReader &);
            };

            class  ClassifyData_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ClassifyData_Response_DataReaderView_ptr _ptr_type;
                typedef ClassifyData_Response_DataReaderView_var _var_type;

                static ClassifyData_Response_DataReaderView_ptr _duplicate (ClassifyData_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClassifyData_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ClassifyData_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClassifyData_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ClassifyData_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClassifyData_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClassifyData_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClassifyData_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClassifyData_Response_& instance) = 0;

            protected:
                ClassifyData_Response_DataReaderView () {};
                ~ClassifyData_Response_DataReaderView () {};
            private:
                ClassifyData_Response_DataReaderView (const ClassifyData_Response_DataReaderView &);
                ClassifyData_Response_DataReaderView & operator = (const ClassifyData_Response_DataReaderView &);
            };
            class Sample_ClassifyData_Request_TypeSupportInterface;

            typedef Sample_ClassifyData_Request_TypeSupportInterface * Sample_ClassifyData_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClassifyData_Request_TypeSupportInterface> Sample_ClassifyData_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ClassifyData_Request_TypeSupportInterface> Sample_ClassifyData_Request_TypeSupportInterface_out;


            class Sample_ClassifyData_Request_DataWriter;

            typedef Sample_ClassifyData_Request_DataWriter * Sample_ClassifyData_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClassifyData_Request_DataWriter> Sample_ClassifyData_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ClassifyData_Request_DataWriter> Sample_ClassifyData_Request_DataWriter_out;


            class Sample_ClassifyData_Request_DataReader;

            typedef Sample_ClassifyData_Request_DataReader * Sample_ClassifyData_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClassifyData_Request_DataReader> Sample_ClassifyData_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ClassifyData_Request_DataReader> Sample_ClassifyData_Request_DataReader_out;


            class Sample_ClassifyData_Request_DataReaderView;

            typedef Sample_ClassifyData_Request_DataReaderView * Sample_ClassifyData_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClassifyData_Request_DataReaderView> Sample_ClassifyData_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ClassifyData_Request_DataReaderView> Sample_ClassifyData_Request_DataReaderView_out;

            struct Sample_ClassifyData_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ClassifyData_Request_, struct Sample_ClassifyData_Request_Seq_uniq_> Sample_ClassifyData_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ClassifyData_Request_Seq> Sample_ClassifyData_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ClassifyData_Request_Seq> Sample_ClassifyData_Request_Seq_out;

            class  Sample_ClassifyData_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ClassifyData_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ClassifyData_Request_TypeSupportInterface_var _var_type;

                static Sample_ClassifyData_Request_TypeSupportInterface_ptr _duplicate (Sample_ClassifyData_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClassifyData_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClassifyData_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ClassifyData_Request_TypeSupportInterface () {};
                ~Sample_ClassifyData_Request_TypeSupportInterface () {};
            private:
                Sample_ClassifyData_Request_TypeSupportInterface (const Sample_ClassifyData_Request_TypeSupportInterface &);
                Sample_ClassifyData_Request_TypeSupportInterface & operator = (const Sample_ClassifyData_Request_TypeSupportInterface &);
            };

            class  Sample_ClassifyData_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ClassifyData_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ClassifyData_Request_DataWriter_var _var_type;

                static Sample_ClassifyData_Request_DataWriter_ptr _duplicate (Sample_ClassifyData_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClassifyData_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClassifyData_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ClassifyData_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ClassifyData_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ClassifyData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ClassifyData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ClassifyData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ClassifyData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ClassifyData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ClassifyData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ClassifyData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ClassifyData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ClassifyData_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClassifyData_Request_& instance_data) = 0;

            protected:
                Sample_ClassifyData_Request_DataWriter () {};
                ~Sample_ClassifyData_Request_DataWriter () {};
            private:
                Sample_ClassifyData_Request_DataWriter (const Sample_ClassifyData_Request_DataWriter &);
                Sample_ClassifyData_Request_DataWriter & operator = (const Sample_ClassifyData_Request_DataWriter &);
            };

            class  Sample_ClassifyData_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ClassifyData_Request_DataReader_ptr _ptr_type;
                typedef Sample_ClassifyData_Request_DataReader_var _var_type;

                static Sample_ClassifyData_Request_DataReader_ptr _duplicate (Sample_ClassifyData_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClassifyData_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClassifyData_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ClassifyData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ClassifyData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ClassifyData_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClassifyData_Request_& instance) = 0;

            protected:
                Sample_ClassifyData_Request_DataReader () {};
                ~Sample_ClassifyData_Request_DataReader () {};
            private:
                Sample_ClassifyData_Request_DataReader (const Sample_ClassifyData_Request_DataReader &);
                Sample_ClassifyData_Request_DataReader & operator = (const Sample_ClassifyData_Request_DataReader &);
            };

            class  Sample_ClassifyData_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ClassifyData_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ClassifyData_Request_DataReaderView_var _var_type;

                static Sample_ClassifyData_Request_DataReaderView_ptr _duplicate (Sample_ClassifyData_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClassifyData_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClassifyData_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ClassifyData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ClassifyData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ClassifyData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ClassifyData_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClassifyData_Request_& instance) = 0;

            protected:
                Sample_ClassifyData_Request_DataReaderView () {};
                ~Sample_ClassifyData_Request_DataReaderView () {};
            private:
                Sample_ClassifyData_Request_DataReaderView (const Sample_ClassifyData_Request_DataReaderView &);
                Sample_ClassifyData_Request_DataReaderView & operator = (const Sample_ClassifyData_Request_DataReaderView &);
            };
            class Sample_ClassifyData_Response_TypeSupportInterface;

            typedef Sample_ClassifyData_Response_TypeSupportInterface * Sample_ClassifyData_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClassifyData_Response_TypeSupportInterface> Sample_ClassifyData_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ClassifyData_Response_TypeSupportInterface> Sample_ClassifyData_Response_TypeSupportInterface_out;


            class Sample_ClassifyData_Response_DataWriter;

            typedef Sample_ClassifyData_Response_DataWriter * Sample_ClassifyData_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClassifyData_Response_DataWriter> Sample_ClassifyData_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ClassifyData_Response_DataWriter> Sample_ClassifyData_Response_DataWriter_out;


            class Sample_ClassifyData_Response_DataReader;

            typedef Sample_ClassifyData_Response_DataReader * Sample_ClassifyData_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClassifyData_Response_DataReader> Sample_ClassifyData_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ClassifyData_Response_DataReader> Sample_ClassifyData_Response_DataReader_out;


            class Sample_ClassifyData_Response_DataReaderView;

            typedef Sample_ClassifyData_Response_DataReaderView * Sample_ClassifyData_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClassifyData_Response_DataReaderView> Sample_ClassifyData_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ClassifyData_Response_DataReaderView> Sample_ClassifyData_Response_DataReaderView_out;

            struct Sample_ClassifyData_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ClassifyData_Response_, struct Sample_ClassifyData_Response_Seq_uniq_> Sample_ClassifyData_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ClassifyData_Response_Seq> Sample_ClassifyData_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ClassifyData_Response_Seq> Sample_ClassifyData_Response_Seq_out;

            class  Sample_ClassifyData_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ClassifyData_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ClassifyData_Response_TypeSupportInterface_var _var_type;

                static Sample_ClassifyData_Response_TypeSupportInterface_ptr _duplicate (Sample_ClassifyData_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClassifyData_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClassifyData_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ClassifyData_Response_TypeSupportInterface () {};
                ~Sample_ClassifyData_Response_TypeSupportInterface () {};
            private:
                Sample_ClassifyData_Response_TypeSupportInterface (const Sample_ClassifyData_Response_TypeSupportInterface &);
                Sample_ClassifyData_Response_TypeSupportInterface & operator = (const Sample_ClassifyData_Response_TypeSupportInterface &);
            };

            class  Sample_ClassifyData_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ClassifyData_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ClassifyData_Response_DataWriter_var _var_type;

                static Sample_ClassifyData_Response_DataWriter_ptr _duplicate (Sample_ClassifyData_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClassifyData_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClassifyData_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ClassifyData_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ClassifyData_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ClassifyData_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ClassifyData_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ClassifyData_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ClassifyData_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ClassifyData_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ClassifyData_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ClassifyData_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ClassifyData_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ClassifyData_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClassifyData_Response_& instance_data) = 0;

            protected:
                Sample_ClassifyData_Response_DataWriter () {};
                ~Sample_ClassifyData_Response_DataWriter () {};
            private:
                Sample_ClassifyData_Response_DataWriter (const Sample_ClassifyData_Response_DataWriter &);
                Sample_ClassifyData_Response_DataWriter & operator = (const Sample_ClassifyData_Response_DataWriter &);
            };

            class  Sample_ClassifyData_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ClassifyData_Response_DataReader_ptr _ptr_type;
                typedef Sample_ClassifyData_Response_DataReader_var _var_type;

                static Sample_ClassifyData_Response_DataReader_ptr _duplicate (Sample_ClassifyData_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClassifyData_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClassifyData_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ClassifyData_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ClassifyData_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ClassifyData_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClassifyData_Response_& instance) = 0;

            protected:
                Sample_ClassifyData_Response_DataReader () {};
                ~Sample_ClassifyData_Response_DataReader () {};
            private:
                Sample_ClassifyData_Response_DataReader (const Sample_ClassifyData_Response_DataReader &);
                Sample_ClassifyData_Response_DataReader & operator = (const Sample_ClassifyData_Response_DataReader &);
            };

            class  Sample_ClassifyData_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ClassifyData_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ClassifyData_Response_DataReaderView_var _var_type;

                static Sample_ClassifyData_Response_DataReaderView_ptr _duplicate (Sample_ClassifyData_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClassifyData_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClassifyData_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClassifyData_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ClassifyData_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ClassifyData_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ClassifyData_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ClassifyData_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClassifyData_Response_& instance) = 0;

            protected:
                Sample_ClassifyData_Response_DataReaderView () {};
                ~Sample_ClassifyData_Response_DataReaderView () {};
            private:
                Sample_ClassifyData_Response_DataReaderView (const Sample_ClassifyData_Response_DataReaderView &);
                Sample_ClassifyData_Response_DataReaderView & operator = (const Sample_ClassifyData_Response_DataReaderView &);
            };
        }

    }

}

#endif
