#ifndef _H_BD9CCB79B075A52C7FCF34441E93CF35_ClearClassifier_DCPS_H_
#define _H_BD9CCB79B075A52C7FCF34441E93CF35_ClearClassifier_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ClearClassifier_.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            class ClearClassifier_Request_TypeSupportInterface;

            typedef ClearClassifier_Request_TypeSupportInterface * ClearClassifier_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ClearClassifier_Request_TypeSupportInterface> ClearClassifier_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ClearClassifier_Request_TypeSupportInterface> ClearClassifier_Request_TypeSupportInterface_out;


            class ClearClassifier_Request_DataWriter;

            typedef ClearClassifier_Request_DataWriter * ClearClassifier_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ClearClassifier_Request_DataWriter> ClearClassifier_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ClearClassifier_Request_DataWriter> ClearClassifier_Request_DataWriter_out;


            class ClearClassifier_Request_DataReader;

            typedef ClearClassifier_Request_DataReader * ClearClassifier_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ClearClassifier_Request_DataReader> ClearClassifier_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ClearClassifier_Request_DataReader> ClearClassifier_Request_DataReader_out;


            class ClearClassifier_Request_DataReaderView;

            typedef ClearClassifier_Request_DataReaderView * ClearClassifier_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ClearClassifier_Request_DataReaderView> ClearClassifier_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ClearClassifier_Request_DataReaderView> ClearClassifier_Request_DataReaderView_out;

            struct ClearClassifier_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ClearClassifier_Request_, struct ClearClassifier_Request_Seq_uniq_> ClearClassifier_Request_Seq;
            typedef DDS_DCPSSequence_var < ClearClassifier_Request_Seq> ClearClassifier_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ClearClassifier_Request_Seq> ClearClassifier_Request_Seq_out;

            class  ClearClassifier_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ClearClassifier_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ClearClassifier_Request_TypeSupportInterface_var _var_type;

                static ClearClassifier_Request_TypeSupportInterface_ptr _duplicate (ClearClassifier_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearClassifier_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ClearClassifier_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearClassifier_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearClassifier_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ClearClassifier_Request_TypeSupportInterface () {};
                ~ClearClassifier_Request_TypeSupportInterface () {};
            private:
                ClearClassifier_Request_TypeSupportInterface (const ClearClassifier_Request_TypeSupportInterface &);
                ClearClassifier_Request_TypeSupportInterface & operator = (const ClearClassifier_Request_TypeSupportInterface &);
            };

            class  ClearClassifier_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ClearClassifier_Request_DataWriter_ptr _ptr_type;
                typedef ClearClassifier_Request_DataWriter_var _var_type;

                static ClearClassifier_Request_DataWriter_ptr _duplicate (ClearClassifier_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearClassifier_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ClearClassifier_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearClassifier_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearClassifier_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ClearClassifier_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ClearClassifier_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ClearClassifier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ClearClassifier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ClearClassifier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ClearClassifier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ClearClassifier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ClearClassifier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ClearClassifier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ClearClassifier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ClearClassifier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClearClassifier_Request_& instance_data) = 0;

            protected:
                ClearClassifier_Request_DataWriter () {};
                ~ClearClassifier_Request_DataWriter () {};
            private:
                ClearClassifier_Request_DataWriter (const ClearClassifier_Request_DataWriter &);
                ClearClassifier_Request_DataWriter & operator = (const ClearClassifier_Request_DataWriter &);
            };

            class  ClearClassifier_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ClearClassifier_Request_DataReader_ptr _ptr_type;
                typedef ClearClassifier_Request_DataReader_var _var_type;

                static ClearClassifier_Request_DataReader_ptr _duplicate (ClearClassifier_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearClassifier_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ClearClassifier_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearClassifier_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearClassifier_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClearClassifier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClearClassifier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClearClassifier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClearClassifier_Request_& instance) = 0;

            protected:
                ClearClassifier_Request_DataReader () {};
                ~ClearClassifier_Request_DataReader () {};
            private:
                ClearClassifier_Request_DataReader (const ClearClassifier_Request_DataReader &);
                ClearClassifier_Request_DataReader & operator = (const ClearClassifier_Request_DataReader &);
            };

            class  ClearClassifier_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ClearClassifier_Request_DataReaderView_ptr _ptr_type;
                typedef ClearClassifier_Request_DataReaderView_var _var_type;

                static ClearClassifier_Request_DataReaderView_ptr _duplicate (ClearClassifier_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearClassifier_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ClearClassifier_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearClassifier_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearClassifier_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClearClassifier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClearClassifier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClearClassifier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClearClassifier_Request_& instance) = 0;

            protected:
                ClearClassifier_Request_DataReaderView () {};
                ~ClearClassifier_Request_DataReaderView () {};
            private:
                ClearClassifier_Request_DataReaderView (const ClearClassifier_Request_DataReaderView &);
                ClearClassifier_Request_DataReaderView & operator = (const ClearClassifier_Request_DataReaderView &);
            };
            class ClearClassifier_Response_TypeSupportInterface;

            typedef ClearClassifier_Response_TypeSupportInterface * ClearClassifier_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ClearClassifier_Response_TypeSupportInterface> ClearClassifier_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ClearClassifier_Response_TypeSupportInterface> ClearClassifier_Response_TypeSupportInterface_out;


            class ClearClassifier_Response_DataWriter;

            typedef ClearClassifier_Response_DataWriter * ClearClassifier_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ClearClassifier_Response_DataWriter> ClearClassifier_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ClearClassifier_Response_DataWriter> ClearClassifier_Response_DataWriter_out;


            class ClearClassifier_Response_DataReader;

            typedef ClearClassifier_Response_DataReader * ClearClassifier_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ClearClassifier_Response_DataReader> ClearClassifier_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ClearClassifier_Response_DataReader> ClearClassifier_Response_DataReader_out;


            class ClearClassifier_Response_DataReaderView;

            typedef ClearClassifier_Response_DataReaderView * ClearClassifier_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ClearClassifier_Response_DataReaderView> ClearClassifier_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ClearClassifier_Response_DataReaderView> ClearClassifier_Response_DataReaderView_out;

            struct ClearClassifier_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ClearClassifier_Response_, struct ClearClassifier_Response_Seq_uniq_> ClearClassifier_Response_Seq;
            typedef DDS_DCPSSequence_var < ClearClassifier_Response_Seq> ClearClassifier_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ClearClassifier_Response_Seq> ClearClassifier_Response_Seq_out;

            class  ClearClassifier_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ClearClassifier_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ClearClassifier_Response_TypeSupportInterface_var _var_type;

                static ClearClassifier_Response_TypeSupportInterface_ptr _duplicate (ClearClassifier_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearClassifier_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ClearClassifier_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearClassifier_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearClassifier_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ClearClassifier_Response_TypeSupportInterface () {};
                ~ClearClassifier_Response_TypeSupportInterface () {};
            private:
                ClearClassifier_Response_TypeSupportInterface (const ClearClassifier_Response_TypeSupportInterface &);
                ClearClassifier_Response_TypeSupportInterface & operator = (const ClearClassifier_Response_TypeSupportInterface &);
            };

            class  ClearClassifier_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ClearClassifier_Response_DataWriter_ptr _ptr_type;
                typedef ClearClassifier_Response_DataWriter_var _var_type;

                static ClearClassifier_Response_DataWriter_ptr _duplicate (ClearClassifier_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearClassifier_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ClearClassifier_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearClassifier_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearClassifier_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ClearClassifier_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ClearClassifier_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ClearClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ClearClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ClearClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ClearClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ClearClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ClearClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ClearClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ClearClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ClearClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClearClassifier_Response_& instance_data) = 0;

            protected:
                ClearClassifier_Response_DataWriter () {};
                ~ClearClassifier_Response_DataWriter () {};
            private:
                ClearClassifier_Response_DataWriter (const ClearClassifier_Response_DataWriter &);
                ClearClassifier_Response_DataWriter & operator = (const ClearClassifier_Response_DataWriter &);
            };

            class  ClearClassifier_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ClearClassifier_Response_DataReader_ptr _ptr_type;
                typedef ClearClassifier_Response_DataReader_var _var_type;

                static ClearClassifier_Response_DataReader_ptr _duplicate (ClearClassifier_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearClassifier_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ClearClassifier_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearClassifier_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearClassifier_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClearClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClearClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClearClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClearClassifier_Response_& instance) = 0;

            protected:
                ClearClassifier_Response_DataReader () {};
                ~ClearClassifier_Response_DataReader () {};
            private:
                ClearClassifier_Response_DataReader (const ClearClassifier_Response_DataReader &);
                ClearClassifier_Response_DataReader & operator = (const ClearClassifier_Response_DataReader &);
            };

            class  ClearClassifier_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ClearClassifier_Response_DataReaderView_ptr _ptr_type;
                typedef ClearClassifier_Response_DataReaderView_var _var_type;

                static ClearClassifier_Response_DataReaderView_ptr _duplicate (ClearClassifier_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearClassifier_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ClearClassifier_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearClassifier_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearClassifier_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClearClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClearClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClearClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClearClassifier_Response_& instance) = 0;

            protected:
                ClearClassifier_Response_DataReaderView () {};
                ~ClearClassifier_Response_DataReaderView () {};
            private:
                ClearClassifier_Response_DataReaderView (const ClearClassifier_Response_DataReaderView &);
                ClearClassifier_Response_DataReaderView & operator = (const ClearClassifier_Response_DataReaderView &);
            };
            class Sample_ClearClassifier_Request_TypeSupportInterface;

            typedef Sample_ClearClassifier_Request_TypeSupportInterface * Sample_ClearClassifier_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearClassifier_Request_TypeSupportInterface> Sample_ClearClassifier_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ClearClassifier_Request_TypeSupportInterface> Sample_ClearClassifier_Request_TypeSupportInterface_out;


            class Sample_ClearClassifier_Request_DataWriter;

            typedef Sample_ClearClassifier_Request_DataWriter * Sample_ClearClassifier_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearClassifier_Request_DataWriter> Sample_ClearClassifier_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ClearClassifier_Request_DataWriter> Sample_ClearClassifier_Request_DataWriter_out;


            class Sample_ClearClassifier_Request_DataReader;

            typedef Sample_ClearClassifier_Request_DataReader * Sample_ClearClassifier_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearClassifier_Request_DataReader> Sample_ClearClassifier_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ClearClassifier_Request_DataReader> Sample_ClearClassifier_Request_DataReader_out;


            class Sample_ClearClassifier_Request_DataReaderView;

            typedef Sample_ClearClassifier_Request_DataReaderView * Sample_ClearClassifier_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearClassifier_Request_DataReaderView> Sample_ClearClassifier_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ClearClassifier_Request_DataReaderView> Sample_ClearClassifier_Request_DataReaderView_out;

            struct Sample_ClearClassifier_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ClearClassifier_Request_, struct Sample_ClearClassifier_Request_Seq_uniq_> Sample_ClearClassifier_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ClearClassifier_Request_Seq> Sample_ClearClassifier_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ClearClassifier_Request_Seq> Sample_ClearClassifier_Request_Seq_out;

            class  Sample_ClearClassifier_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ClearClassifier_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ClearClassifier_Request_TypeSupportInterface_var _var_type;

                static Sample_ClearClassifier_Request_TypeSupportInterface_ptr _duplicate (Sample_ClearClassifier_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearClassifier_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearClassifier_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ClearClassifier_Request_TypeSupportInterface () {};
                ~Sample_ClearClassifier_Request_TypeSupportInterface () {};
            private:
                Sample_ClearClassifier_Request_TypeSupportInterface (const Sample_ClearClassifier_Request_TypeSupportInterface &);
                Sample_ClearClassifier_Request_TypeSupportInterface & operator = (const Sample_ClearClassifier_Request_TypeSupportInterface &);
            };

            class  Sample_ClearClassifier_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ClearClassifier_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ClearClassifier_Request_DataWriter_var _var_type;

                static Sample_ClearClassifier_Request_DataWriter_ptr _duplicate (Sample_ClearClassifier_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearClassifier_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearClassifier_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ClearClassifier_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ClearClassifier_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ClearClassifier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ClearClassifier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ClearClassifier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ClearClassifier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ClearClassifier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ClearClassifier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ClearClassifier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ClearClassifier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ClearClassifier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClearClassifier_Request_& instance_data) = 0;

            protected:
                Sample_ClearClassifier_Request_DataWriter () {};
                ~Sample_ClearClassifier_Request_DataWriter () {};
            private:
                Sample_ClearClassifier_Request_DataWriter (const Sample_ClearClassifier_Request_DataWriter &);
                Sample_ClearClassifier_Request_DataWriter & operator = (const Sample_ClearClassifier_Request_DataWriter &);
            };

            class  Sample_ClearClassifier_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ClearClassifier_Request_DataReader_ptr _ptr_type;
                typedef Sample_ClearClassifier_Request_DataReader_var _var_type;

                static Sample_ClearClassifier_Request_DataReader_ptr _duplicate (Sample_ClearClassifier_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearClassifier_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearClassifier_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ClearClassifier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ClearClassifier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ClearClassifier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClearClassifier_Request_& instance) = 0;

            protected:
                Sample_ClearClassifier_Request_DataReader () {};
                ~Sample_ClearClassifier_Request_DataReader () {};
            private:
                Sample_ClearClassifier_Request_DataReader (const Sample_ClearClassifier_Request_DataReader &);
                Sample_ClearClassifier_Request_DataReader & operator = (const Sample_ClearClassifier_Request_DataReader &);
            };

            class  Sample_ClearClassifier_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ClearClassifier_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ClearClassifier_Request_DataReaderView_var _var_type;

                static Sample_ClearClassifier_Request_DataReaderView_ptr _duplicate (Sample_ClearClassifier_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearClassifier_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearClassifier_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ClearClassifier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ClearClassifier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ClearClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ClearClassifier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClearClassifier_Request_& instance) = 0;

            protected:
                Sample_ClearClassifier_Request_DataReaderView () {};
                ~Sample_ClearClassifier_Request_DataReaderView () {};
            private:
                Sample_ClearClassifier_Request_DataReaderView (const Sample_ClearClassifier_Request_DataReaderView &);
                Sample_ClearClassifier_Request_DataReaderView & operator = (const Sample_ClearClassifier_Request_DataReaderView &);
            };
            class Sample_ClearClassifier_Response_TypeSupportInterface;

            typedef Sample_ClearClassifier_Response_TypeSupportInterface * Sample_ClearClassifier_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearClassifier_Response_TypeSupportInterface> Sample_ClearClassifier_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ClearClassifier_Response_TypeSupportInterface> Sample_ClearClassifier_Response_TypeSupportInterface_out;


            class Sample_ClearClassifier_Response_DataWriter;

            typedef Sample_ClearClassifier_Response_DataWriter * Sample_ClearClassifier_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearClassifier_Response_DataWriter> Sample_ClearClassifier_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ClearClassifier_Response_DataWriter> Sample_ClearClassifier_Response_DataWriter_out;


            class Sample_ClearClassifier_Response_DataReader;

            typedef Sample_ClearClassifier_Response_DataReader * Sample_ClearClassifier_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearClassifier_Response_DataReader> Sample_ClearClassifier_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ClearClassifier_Response_DataReader> Sample_ClearClassifier_Response_DataReader_out;


            class Sample_ClearClassifier_Response_DataReaderView;

            typedef Sample_ClearClassifier_Response_DataReaderView * Sample_ClearClassifier_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearClassifier_Response_DataReaderView> Sample_ClearClassifier_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ClearClassifier_Response_DataReaderView> Sample_ClearClassifier_Response_DataReaderView_out;

            struct Sample_ClearClassifier_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ClearClassifier_Response_, struct Sample_ClearClassifier_Response_Seq_uniq_> Sample_ClearClassifier_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ClearClassifier_Response_Seq> Sample_ClearClassifier_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ClearClassifier_Response_Seq> Sample_ClearClassifier_Response_Seq_out;

            class  Sample_ClearClassifier_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ClearClassifier_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ClearClassifier_Response_TypeSupportInterface_var _var_type;

                static Sample_ClearClassifier_Response_TypeSupportInterface_ptr _duplicate (Sample_ClearClassifier_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearClassifier_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearClassifier_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ClearClassifier_Response_TypeSupportInterface () {};
                ~Sample_ClearClassifier_Response_TypeSupportInterface () {};
            private:
                Sample_ClearClassifier_Response_TypeSupportInterface (const Sample_ClearClassifier_Response_TypeSupportInterface &);
                Sample_ClearClassifier_Response_TypeSupportInterface & operator = (const Sample_ClearClassifier_Response_TypeSupportInterface &);
            };

            class  Sample_ClearClassifier_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ClearClassifier_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ClearClassifier_Response_DataWriter_var _var_type;

                static Sample_ClearClassifier_Response_DataWriter_ptr _duplicate (Sample_ClearClassifier_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearClassifier_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearClassifier_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ClearClassifier_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ClearClassifier_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ClearClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ClearClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ClearClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ClearClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ClearClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ClearClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ClearClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ClearClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ClearClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClearClassifier_Response_& instance_data) = 0;

            protected:
                Sample_ClearClassifier_Response_DataWriter () {};
                ~Sample_ClearClassifier_Response_DataWriter () {};
            private:
                Sample_ClearClassifier_Response_DataWriter (const Sample_ClearClassifier_Response_DataWriter &);
                Sample_ClearClassifier_Response_DataWriter & operator = (const Sample_ClearClassifier_Response_DataWriter &);
            };

            class  Sample_ClearClassifier_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ClearClassifier_Response_DataReader_ptr _ptr_type;
                typedef Sample_ClearClassifier_Response_DataReader_var _var_type;

                static Sample_ClearClassifier_Response_DataReader_ptr _duplicate (Sample_ClearClassifier_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearClassifier_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearClassifier_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ClearClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ClearClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ClearClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClearClassifier_Response_& instance) = 0;

            protected:
                Sample_ClearClassifier_Response_DataReader () {};
                ~Sample_ClearClassifier_Response_DataReader () {};
            private:
                Sample_ClearClassifier_Response_DataReader (const Sample_ClearClassifier_Response_DataReader &);
                Sample_ClearClassifier_Response_DataReader & operator = (const Sample_ClearClassifier_Response_DataReader &);
            };

            class  Sample_ClearClassifier_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ClearClassifier_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ClearClassifier_Response_DataReaderView_var _var_type;

                static Sample_ClearClassifier_Response_DataReaderView_ptr _duplicate (Sample_ClearClassifier_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearClassifier_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearClassifier_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearClassifier_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ClearClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ClearClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ClearClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ClearClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClearClassifier_Response_& instance) = 0;

            protected:
                Sample_ClearClassifier_Response_DataReaderView () {};
                ~Sample_ClearClassifier_Response_DataReaderView () {};
            private:
                Sample_ClearClassifier_Response_DataReaderView (const Sample_ClearClassifier_Response_DataReaderView &);
                Sample_ClearClassifier_Response_DataReaderView & operator = (const Sample_ClearClassifier_Response_DataReaderView &);
            };
        }

    }

}

#endif
