#ifndef _H_ED19BFC380FE36726A347EBB0D556534_SaveClassifier__H_
#define _H_ED19BFC380FE36726A347EBB0D556534_SaveClassifier__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            struct  SaveClassifier_Request_
            {
                ::DDS::String_mgr identifier_;
                ::DDS::String_mgr filename_;
            };

            typedef DDS_DCPSStruct_var<SaveClassifier_Request_> SaveClassifier_Request__var;
            typedef DDS_DCPSStruct_out < SaveClassifier_Request_> SaveClassifier_Request__out;

            struct  SaveClassifier_Response_
            {
                ::DDS::Boolean success_;
            };

            typedef DDS_DCPSStruct_var<SaveClassifier_Response_> SaveClassifier_Response__var;
            typedef SaveClassifier_Response_& SaveClassifier_Response__out;

            struct  Sample_SaveClassifier_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::SaveClassifier_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_SaveClassifier_Request_> Sample_SaveClassifier_Request__var;
            typedef DDS_DCPSStruct_out < Sample_SaveClassifier_Request_> Sample_SaveClassifier_Request__out;

            struct  Sample_SaveClassifier_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::SaveClassifier_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_SaveClassifier_Response_> Sample_SaveClassifier_Response__var;
            typedef Sample_SaveClassifier_Response_& Sample_SaveClassifier_Response__out;

        }

    }

}

#endif /* _H_ED19BFC380FE36726A347EBB0D556534_SaveClassifier__H_ */
